# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pike character.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class SimplePosition(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'title': 'str',
        'hours_per_full_work_day': 'float',
        'position_type': 'Int32IdNameClass',
        'needs_replacement': 'NeedsReplacementEnum',
        'id': 'int',
        'external_id': 'str'
    }

    attribute_map = {
        'title': 'title',
        'hours_per_full_work_day': 'hoursPerFullWorkDay',
        'position_type': 'positionType',
        'needs_replacement': 'needsReplacement',
        'id': 'id',
        'external_id': 'externalId'
    }

    def __init__(self, title=None, hours_per_full_work_day=None, position_type=None, needs_replacement=None, id=None, external_id=None, local_vars_configuration=None):  # noqa: E501
        """SimplePosition - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._title = None
        self._hours_per_full_work_day = None
        self._position_type = None
        self._needs_replacement = None
        self._id = None
        self._external_id = None
        self.discriminator = None

        self.title = title
        self.hours_per_full_work_day = hours_per_full_work_day
        if position_type is not None:
            self.position_type = position_type
        if needs_replacement is not None:
            self.needs_replacement = needs_replacement
        if id is not None:
            self.id = id
        self.external_id = external_id

    @property
    def title(self):
        """Gets the title of this SimplePosition.  # noqa: E501

        The name of the Position  # noqa: E501

        :return: The title of this SimplePosition.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this SimplePosition.

        The name of the Position  # noqa: E501

        :param title: The title of this SimplePosition.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def hours_per_full_work_day(self):
        """Gets the hours_per_full_work_day of this SimplePosition.  # noqa: E501

        Hours per full work day  # noqa: E501

        :return: The hours_per_full_work_day of this SimplePosition.  # noqa: E501
        :rtype: float
        """
        return self._hours_per_full_work_day

    @hours_per_full_work_day.setter
    def hours_per_full_work_day(self, hours_per_full_work_day):
        """Sets the hours_per_full_work_day of this SimplePosition.

        Hours per full work day  # noqa: E501

        :param hours_per_full_work_day: The hours_per_full_work_day of this SimplePosition.  # noqa: E501
        :type: float
        """

        self._hours_per_full_work_day = hours_per_full_work_day

    @property
    def position_type(self):
        """Gets the position_type of this SimplePosition.  # noqa: E501


        :return: The position_type of this SimplePosition.  # noqa: E501
        :rtype: Int32IdNameClass
        """
        return self._position_type

    @position_type.setter
    def position_type(self, position_type):
        """Sets the position_type of this SimplePosition.


        :param position_type: The position_type of this SimplePosition.  # noqa: E501
        :type: Int32IdNameClass
        """

        self._position_type = position_type

    @property
    def needs_replacement(self):
        """Gets the needs_replacement of this SimplePosition.  # noqa: E501


        :return: The needs_replacement of this SimplePosition.  # noqa: E501
        :rtype: NeedsReplacementEnum
        """
        return self._needs_replacement

    @needs_replacement.setter
    def needs_replacement(self, needs_replacement):
        """Sets the needs_replacement of this SimplePosition.


        :param needs_replacement: The needs_replacement of this SimplePosition.  # noqa: E501
        :type: NeedsReplacementEnum
        """

        self._needs_replacement = needs_replacement

    @property
    def id(self):
        """Gets the id of this SimplePosition.  # noqa: E501


        :return: The id of this SimplePosition.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SimplePosition.


        :param id: The id of this SimplePosition.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def external_id(self):
        """Gets the external_id of this SimplePosition.  # noqa: E501


        :return: The external_id of this SimplePosition.  # noqa: E501
        :rtype: str
        """
        return self._external_id

    @external_id.setter
    def external_id(self, external_id):
        """Sets the external_id of this SimplePosition.


        :param external_id: The external_id of this SimplePosition.  # noqa: E501
        :type: str
        """

        self._external_id = external_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SimplePosition):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SimplePosition):
            return True

        return self.to_dict() != other.to_dict()
